<?php
/** function libary **/
function stripslashes_array(&$array) {
 	while(list($key,$val)=each($array)) {
  		if($key=="uploadfile") continue;
  		if(is_string($val)) $array[$key]=stripslashes($val);
  		elseif(is_array($val)) $array[$key]=stripslashes_array($val);
 	}
 	return $array;
}


function makeimgtag($path,$alt="") {
 	return "<img src=\"$path\" ".(($alt!="") ? ("alt=\"".$alt."\" ") : (""))."border=\"0\" />";
}


function makehreftag($url,$text,$target="") {
 	return "<a href=\"".$url."\"".(($target) ? (" target=\"".$target."\"") : ("")).">".$text."</a>";

}


function formatdate($timeformat,$timestamp) {
 	global $timezoneoffset;

 	$summertime = date("I")*3600;
 	$timestamp+=3600*intval($timezoneoffset)+$summertime;
 	return gmdate($timeformat, $timestamp);
}


function parse($post, $nosmilies, $smiliepath="") {
 	global $db, $n, $searcharray, $replacearray, $smiliecache, $dosmiliescache, $allowbbcode, $allowsmilies, $allowhtml, $allowimages, $docensor, $censorwords, $censorcover;

 	$post = textwrap($post);

 	// html
  	if($allowhtml==0) {
  	$post=htmlconverter($post);
   	$post = nl2br($post);
  	}
  	else $post=preg_replace("/<([\/]?)script([^>]*)>/i","&lt;\\1script\\2&gt;",$post);

 	$post = str_replace("\t", " ", $post);

 	if($allowsmilies==1 && $nosmilies!=1) {
  		if(!isset($dosmiliescache)) {
   			$dosmiliescache=1;
   			$result=$db->query("SELECT * FROM bgb".$n."_smilies ORDER BY smilieid DESC");
   			$count=0;
   			while($row=$db->fetch_array($result)) {
    				$smiliecache[$count] = $row;
    				$smiliecache[$count]['path'] = $smiliepath."images/smilies/smilie-".$row['smilieid'].".".$row['smilieextension'];
    				$count++;
   			}
  		}

  		for($i=0;$i<count($smiliecache);$i++) $post=str_replace($smiliecache[$i]['smiliecode'],makeimgtag($smiliecache[$i]['path'],$smiliecache[$i]['smilietitle']), $post);
 	}

 	if($allowbbcode) {
  		if(!isset($searcharray) || !isset($replacearray)) {
   			$searcharray[]="/\[url=(['\"]?)(www\.)([^\"']*)\\1](.*)\[\/url\]/siU";
   			$replacearray[]="<a href=\"http://www.\\3\" target=\"_blank\">\\4</a>";
   			$searcharray[]="/\[url=(['\"]?)([^\"']*)\\1](.*)\[\/url\]/siU";
   			$replacearray[]="<a href=\"\\2\" target=\"_blank\">\\3</a>";
   			$searcharray[]="/\[url](www\.)([^\"]*)\[\/url\]/siU";
   			$replacearray[]="<a href=\"http://www.\\2\" target=\"_blank\">\\1\\2</a>";
   			$searcharray[]="/\[url]([^\"]*)\[\/url\]/siU";
   			$replacearray[]="<a href=\"\\1\" target=\"_blank\">\\1</a>";
   			$searcharray[]="/\[img]([^\"]*)\[\/img\]/siU";

   			if($allowimages) $replacearray[]="<img src=\"\\1\" border=0>";
   			else $replacearray[]="<a href=\"\\1\" target=\"_blank\">\\1</a>";

   			$threeparams = "/\[%s=(['\"]?)([^\"']*),([^\"']*)\\1](.*)\[\/%s\]/siU";
   			$twoparams = "/\[%s=(['\"]?)([^\"']*)\\1](.*)\[\/%s\]/siU";
   			$oneparam = "/\[%s](.*)\[\/%s\]/siU";

   			$result = $db->query("SELECT codetag,replaces,params FROM bgb".$n."_codes");

   			while($row = $db->fetch_array($result)) {
    				if($row['params']==1) $search = sprintf($oneparam, $row['codetag'], $row['codetag']);
    				if($row['params']==2) $search = sprintf($twoparams, $row['codetag'], $row['codetag']);
    				if($row['params']==3) $search = sprintf($threeparams, $row['codetag'], $row['codetag']);

    				$searcharray[] = $search;
    				$replacearray[] = $row['replaces'];
   			}
  		}

  		$post = preg_replace($searcharray, $replacearray, $post);
 	}

 	if($docensor==1) {
  		$censorWordsArray=explode("\n",$censorwords);
  		$censorsearch=array();
  		$censorreplace=array();
  		for($i=0;$i<count($censorWordsArray);$i++) {
   			$censorWordsArray[$i]=trim($censorWordsArray[$i]);
   			if(!$censorWordsArray[$i]) continue;

   			if(preg_match("/\{([^=]+)=([^=]*)\}/si",$censorWordsArray[$i],$exp)) {
     				$censorsearch[] = "/(^|\s|\]|>|\")(".preg_quote($exp[1]).")(([,\.]{1}[\s[\"<$]+)|\s|\[|\"|<|$)/i";
     				$censorreplace[] = "\\1".$exp[2]."\\3";
    			}
    			elseif(preg_match("/\{([^=]+)\}/si",$censorWordsArray[$i],$exp)) {
     				$censorsearch[] = "/(^|\s|\]|>|\")(".preg_quote($exp[1]).")(([,\.]{1}[\s[\"<$]+)|\s|\[|\"|<|$)/i";
     				$censorreplace[] = "\\1".strrepeat($censorcover, strlen($exp[1]))."\\3";
    			}
    			elseif(preg_match("/([^=]+)=([^=]*)/si",$censorWordsArray[$i],$exp)) {
     				$censorsearch[] = "/".preg_quote($exp[1])."/i";
     				$censorreplace[] = $exp[2];
    			}
    			else {
    				$censorsearch[] = "/".preg_quote($censorWordsArray[$i])."/i";
     				$censorreplace[] = strrepeat($censorcover, strlen($censorWordsArray[$i]));
    			}
  		}

  		if(count($censorsearch)>0 && count($censorreplace)>0) $post = preg_replace($censorsearch, $censorreplace, $post);
 	}

 	return $post;
}


function makepagelink($link, $page, $pages, $char='?') {
 	global $template;
 	$pagelink = $template->get("page")." ".$page."/".$pages.": ";

 	if($page-5>1) $pagelink.="[".makehreftag($link.$char."page=1","&laquo;")."] ";
 	if($page>1) $pagelink.="[".makehreftag($link.$char."page=".($page-1),"")."] ";

 	$count = (($page+5>=$pages) ? ($pages) : ($page+5));
 	for($i=$page-5;$i<=$count;$i++) {
  		if($i<1) $i=1;
  		if($i==$page) $pagelink.="($i) ";
  		else $pagelink.="[".makehreftag($link.$char."page=".($i),$i)."] ";
 	}

 	if($page<$pages) $pagelink.="[".makehreftag($link.$char."page=".($page+1),"&gt;")."] ";
 	if($page+5<$pages) $pagelink.="[".makehreftag($link.$char."page=".$pages,"&raquo;")."]";

 	return $pagelink;
}


function htmlchars($string) {
 	$string=str_replace("<","&lt;",$string);
 	$string=str_replace(">","&gt;",$string);
 	$string=str_replace("\"","&quot;",$string);
 	return $string;
}


function htmlchars_array(&$array) {
 	while(list($key,$val)=each($array)) {
  		if(is_array($val)) $array[$key]=htmlchars_array($val);
 		elseif(is_string($val)) $array[$key]=htmlchars($val);
 	}

 	return $array;
}


function rehtmlchars($string) {
 	$string=str_replace("&lt;","<",$string);
 	$string=str_replace("&gt;",">",$string);
 	$string=str_replace("&quot;","\"",$string);
 	return $string;
}


function rehtmlchars_array(&$array) {
 	while(list($key,$val)=each($array)) {
  		if(is_array($val)) $array[$key]=rehtmlchars_array($val);
  		elseif(is_string($val)) $array[$key]=rehtmlchars($val);
 	}

 	return $array;
}


function trim_array(&$array) {
 	while(list($key,$val)=each($array)) {
  		if(is_array($val)) $array[$key]=trim_array($val);
  		elseif(is_string($val)) $array[$key]=trim($val);
 	}

 	return $array;
}


function htmlspecialchars_array(&$array) {
 	while(list($key,$val)=each($array)) {
  		if(is_string($val)) $array[$key]=addslashes(htmlspecialchars($val));
 		elseif(is_array($val)) $array[$key]=htmlspecialchars_array($val);
 	}

 	return $array;
}


function parseURL($post) {
 	$urlsearch[]="/([^]_a-z0-9-=\"'\/])((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";
 	$urlsearch[]="/^((https?|ftp):\/\/|www\.)([^ \r\n\(\)\*\^\$!`\"'\|\[\]\{\};<>]*)/si";
 	$urlreplace[]="\\1[URL]\\2\\4[/URL]";
 	$urlreplace[]="[URL]\\1\\3[/URL]";
 	$emailsearch[]="/([\s])([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
 	$emailsearch[]="/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si";
 	$emailreplace[]="\\1[EMAIL]\\2[/EMAIL]";
 	$emailreplace[]="[EMAIL]\\0[/EMAIL]";
 	$post = preg_replace($urlsearch, $urlreplace, $post);
 	if (strpos($post, "@")) $post = preg_replace($emailsearch, $emailreplace, $post);

 	return $post;
}

function textwrap($text, $width = 75) {
 	if($text) return preg_replace("/([^\n\r ?&\.\/<>\"\\-]{".$width."})/i"," \\1\n",$text);
}

function strrepeat($str, $x) {
 	$returnstr="";
 	for($i=0;$i<$x;$i++) $returnstr.=$str;
 	return $returnstr;
}

function doabstract($text, $length) {
 	$read=0;
 	$read2=0;
 	$newtext="";
 	for($i=0;$i<strlen($text);$i++) {
  		if($text[$i]=='[' && $read<=0) $read++;
  		elseif($text[$i]=='[' && $read>0) $read--;

  		if($text[$i]==']' && $read2<=0) $read2++;
  		elseif($text[$i]==']' && $read2>0) $read2--;

  		$newtext.=$text[$i];
  		if($read==0 && $read2==0) $length--;
  		if($length==0 && $read==0 && $read2==0) break;
 	}
 	return $newtext;
}

/** get the client ip address **/
function getIpAddress() {
 	global $_SERVER;

 	$REMOTE_ADDR=$_SERVER['REMOTE_ADDR'];
 	if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $HTTP_X_FORWARDED_FOR=$_SERVER['HTTP_X_FORWARDED_FOR'];
 	else $HTTP_X_FORWARDED_FOR="";

 	if($HTTP_X_FORWARDED_FOR!="") {
  		if(preg_match("/^([0-9]+\.[0-9]+\.[0-9]+\.[0-9]+)/", $HTTP_X_FORWARDED_FOR, $ip_match)) {
   			$private_ip_list = array("/^0\./", "/^127\.0\.0\.1/", "/^192\.168\..*/", "/^172\.16\..*/", "/^10..*/", "/^224..*/", "/^240..*/");
   			$REMOTE_ADDR = preg_replace($private_ip_list, $REMOTE_ADDR, $ip_match[1]);
  		}
 	}

 	if(strlen($REMOTE_ADDR)>16) $REMOTE_ADDR=substr($REMOTE_ADDR, 0, 16);
	return $REMOTE_ADDR;
}


/** compress output **/
function compress() {
 	global $_SERVER;

 	if(strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') && function_exists("gzcompress")) {
  		ob_start("gzoutput");
  		@header("Content-Encoding: gzip");
 	}
}

function gzoutput($output) {
 	$size = strlen($output);
 	$newoutput = "\x1f\x8b\x08\x00\x00\x00\x00\x00";
 	$newoutput .= substr(gzcompress($output, 1), 0, -4);
 	$newoutput .= pack("V", $size);

 	return $newoutput;
}

function convertHTML($text) {
	return htmlentities($text);
}

/** verify a email **/
function verify_email($email) {
	$email=strtolower($email);
	if(!preg_match("/^([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,}))/si",$email))
	return false;
	else return true;
}

/** generate a new activation code **/
function code_generate() {
	$time = intval(substr(microtime(), 2, 8));
	mt_srand($time);

	return mt_rand(1000000,10000000);
}

/** generate a new password **/
function password_generate($numbers=2,$length=8) {

 $time = intval(substr(microtime(), 2, 8));
 mt_srand($time);

 $numberchain="1234567890";

 for($i=0;$i<$numbers;$i++) {
  $random=mt_rand(0,strlen($numberchain)-1);
  $number[intval($numberchain[$random])]=mt_rand(1,9);
  $numberchain=str_replace($random,"",$numberchain);
 }

 $chain = "abcdefghijklmnopqrstuvwxyz";
 for($i=0;$i<$length;$i++) {
  if($number[$i]) $password.=$number[$i];
  else $password.=$chain[mt_rand(0,strlen($chain)-1)];
 }
 return $password;
}

/** htmlconverter function **/
function htmlconverter($text) {
 static $charset;
 global $phpversion;

 if(!isset($charset)) {
  global $lang_encoding;
  if(isset($lang_encoding) && $lang_encoding) $charset=strtolower($lang_encoding);
  else $charset="";
 }
 if(version_compare($phpversion, "4.3.0")>=0 && ($charset=="iso-8859-1" || $charset=="iso-8859-15" || $charset=="utf-8" || $charset=="cp1252" || $charset=="windows-1252" || $charset=="koi8-r" || $charset=="big5" || $charset=="gb2312" || $charset=="big5-hkscs" || $charset=="shift_jis" || $charset=="euc-jp")) return @htmlentities($text, ENT_COMPAT, $charset);
 elseif($charset=="iso-8859-1" || $charset=="windows-1252") return htmlentities($text);
 else return htmlspecialchars($text);
}

/** function version_compare for php < 4.1.0 **/
if(!function_exists("version_compare")) {
 function version_compare( $vercurrent, $vercheck ) {
  $minver = explode(".", $vercheck);
  $curver = explode(".", $vercurrent);

  if (($curver[0] < $minver[0]) || (($curver[0] == $minver[0]) && ($curver[1] < $minver[1])) || (($curver[0] == $minver[0]) && ($curver[1] == $minver[1]) && ($curver[2][0] < $minver[2][0])))
   return -1;
  elseif($curver[0] == $minver[0] && $curver[1] == $minver[1] && $curver[2] == $minver[2])
   return 0;
  else
   return 1;
 }
}
?>