<?php
$templatelist = "page,view,view_postbit_del,view_postbit_comment,index_fields,view_postbit,index_commentrow,index_iconsemail,index_iconshomepage,index_iconsicq,index_iconsaim,index_iconsyim,index_iconsmsn,view_priorpage,view_nextpage,bbcode_sizebits,bbcode_fontbits,bbcode_colorbits,addentry_bbcodes,addentry_smilies_getmore,addentry_smiliebit,addentry_smilies,addentry_codes";

require("./global.php");

if (!isset($_SESSION['isadmin'])) {
 	die("error");
}

// var def
$header = "";
$footer = "";
$checkbox 			= array("", "");
$addentry_smilies_getmore 	= "";
$preview	 	= "";

if (isset($_REQUEST['action'])) $action=$_REQUEST['action'];
else $action="";

// delete post
if ($action == "deletesure" && isset($_POST['postid'])) {
 	$postid = intval($_POST['postid']);
 	$db->query("DELETE FROM bgb".$n."_posts WHERE postid = '".$postid."'");
 	$db->query("DELETE FROM bgb".$n."_fields WHERE postid = '".$postid."'");
}

// add a comment
if ($action == "writecomment" && isset($_POST['postid'])) {
 	$postid = intval($_POST['postid']);

 	if(isset($_POST['preview'])) $action = "addcomment";
 	else {

  		if (isset($_POST['message'])) $message = trim($_POST['message']);
  		else $message = "";

  		if (isset($_POST['parseurl'])) $parseurl = intval($_POST['parseurl']);
  		else $parseurl = 0;

  		if (isset($_POST['nosmilies'])) $nosmilies = intval($_POST['nosmilies']);
  		else $nosmilies = 0;


  		if ($parseurl == 1) $message = parseurl($message);


  		$db->query("UPDATE bgb".$n."_posts SET comment = '".addslashes($message)."', commenttime = '".time()."', comment_nosmilies = '".$nosmilies."' WHERE postid = '".$postid."'");
 	}
}

// get page no.
if (isset($_REQUEST['page'])) {
	$page = intval($_REQUEST['page']);
	if ($page == 0) $page = 1;
}
else $page = 1;

// get total post count
list($totalposts)=$db->query_first("SELECT COUNT(postid) FROM bgb".$n."_posts");

// get pages amount
$pages=ceil($totalposts/$perpage);
if($page>$pages) $page=$pages;

$count		= 0;
$fieldids 	= array();
$fieldtitles 	= array();

// get post fields
$result=$db->query("SELECT fieldid, title FROM bgb".$n."_fieldsettings ORDER BY displayorder ASC");
while ($row=$db->fetch_array($result)) {
 	$fieldids[$count]=$row['fieldid'];
 	$fieldtitles[$count]=$row['title'];
 	$count++;
}

// get post IDs
$postids = "";
$result=$db->query("SELECT postid FROM bgb".$n."_posts ORDER BY posttime ".(($displayorder) ? ("ASC") : ("DESC"))." LIMIT ". (($page - 1) * $perpage) . "," . $perpage);
while ($row=$db->fetch_array($result)) $postids .= "," . $row['postid'];


// get posts
$posts=$db->query("
 	SELECT bgb".$n."_posts.*, bgb".$n."_fields.*, bgb".$n."_icons.*
 	FROM bgb".$n."_posts
 	LEFT JOIN bgb".$n."_fields ON (bgb".$n."_fields.postid=bgb".$n."_posts.postid)
 	LEFT JOIN bgb".$n."_icons ON (bgb".$n."_icons.iconid=bgb".$n."_posts.iconid)
 	WHERE bgb".$n."_posts.postid IN (0".$postids.")
 	ORDER BY posttime ".(($displayorder) ? ("ASC") : ("DESC")));

$count = (($displayorder) ? (($page - 1) * $perpage) : ($totalposts + 1 - ($page - 1) * $perpage));
$postbit = "";
while ($post=$db->fetch_array($posts)) {
 	$icons		= "";
 	$fields		= "";
 	$suffix		= "";
 	$comment 	= "";

 	// get post no.
 	if ($displayorder==1) $count++;
 	else $count--;

 	// get cell color
 	if($count % 2) $tableid = "tablea";
 	else $tableid = "tableb";

	// get post field data
 	for ($i = 0; $i < count($fieldids); $i++) {
  		if (!isset($post["field".$fieldids[$i]])) continue;
  		$field = trim($post["field".$fieldids[$i]]);
  		$field = htmlconverter(stripslashes($field));
  		$field = textwrap($field, 25);
  		if (!$field) continue;

  		$fieldtitle = $fieldtitles[$i];
  		eval("\$fields .= \"".$template->get("index_fields")."\";");
 	}

 	// format postdata
 	$posttime = formatdate($timeformat, $post['posttime']);

 	// get posticon
 	if ($post['iconid'] && $allowicons) $icon = makeimgtag("images/icons/icon-".$post['iconid'].".".$post['iconextension'], $post['icontitle'])."<br />";
 	else $icon = "";

 	// parse message
 	$post['message'] = parse(stripslashes($post['message']), $post['nosmilies']);

 	// parse comment
 	if ($post['comment'] != "") {
  		$comment = $post['comment'];
  		$post['comment'] = parse(stripslashes($post['comment']), $post['comment_nosmilies']);
  		$commenttime = formatdate($timeformat, $post['commenttime']);
  		eval("\$commentrow = \"".$template->get("index_commentrow")."\";");
 	}
 	else $commentrow = "";

	$post['email'] = htmlconverter(stripslashes($post['email']));
	$post['homepage'] = htmlconverter(stripslashes($post['homepage']));
	$post['icq'] = intval($post['icq']);
	$post['aim'] = htmlconverter(stripslashes($post['aim']));
	$post['yim'] = htmlconverter(stripslashes($post['yim']));
	$post['msn'] = htmlconverter(stripslashes($post['msn']));

 	// get default fields
 	if($post['email'] && $allowemail==1) eval("\$icons .= \"".$template->get("index_iconsemail")."\";");
 	if($post['homepage'] && $allowhomepage==1) eval("\$icons .= \"".$template->get("index_iconshomepage")."\";");
 	if($post['icq'] && $allowicq==1) eval("\$icons .= \"".$template->get("index_iconsicq")."\";");
 	if($post['aim'] && $allowaim==1) eval("\$icons .= \"".$template->get("index_iconsaim")."\";");
 	if($post['yim'] && $allowyim==1) eval("\$icons .= \"".$template->get("index_iconsyim")."\";");
	if($post['msn'] && $allowmsn==1) eval("\$icons .= \"".$template->get("index_iconsmsn")."\";");

	$post['useragent'] = htmlconverter(stripslashes($post['useragent']));
	$post['authorname'] = htmlconverter(stripslashes($post['authorname']));
	$post['authorname'] = textwrap($post['authorname'], 25);

 	if (isset($_REQUEST['postid']) && $_REQUEST['postid'] == $post['postid']) {

  		if ($action == "delete") $suffix = "_del";
  		if ($action == "addcomment") {
   			if ($ch_parseurl == 1) $checkbox[0] = " checked=\"checked\"";
   			if ($ch_nosmilies == 1 || $post['comment_nosmilies'] == 1) $checkbox[1] = " checked=\"checked\"";

   			if(isset($_POST['preview']) && $_POST['preview']) {
    				if (isset($_POST['nosmilies']) && $_POST['nosmilies'] == 1) {
    					$nosmilies = 1;
    					$checkbox[1] = " checked=\"checked\"";
    				}
    				else {
    					$checkbox[1] = "";
    					$nosmilies = 0;
    				}

    				if (isset($_POST['parseurl']) && $_POST['parseurl'] == 1) $checkbox[0] = " checked=\"checked\"";
    				else $checkbox[0] = "";

    				$message = trim($_POST['message']);
    				if (isset($_POST['parseurl']) && $_POST['parseurl']== 1) $message = parseurl($message);
    				if (!$message) $commentrow="";
    				else {
     					$comment = $message;
     					$post['comment']=parse($message, $nosmilies);
     					$commenttime = formatdate($timeformat, time());
     					eval("\$commentrow = \"".$template->get("index_commentrow")."\";");
    				}
   			}

   			$suffix = "_comment";
   			if ($allowbbcode == 1 || $allowsmilies == 1) {
    				if ($allowbbcode == 1) {
     					eval("\$bbcode_sizebits = \"".$template->get("bbcode_sizebits")."\";");
     					eval("\$bbcode_fontbits = \"".$template->get("bbcode_fontbits")."\";");
     					eval("\$bbcode_colorbits = \"".$template->get("bbcode_colorbits")."\";");

     					eval("\$addentry_bbcodes = \"".$template->get("addentry_bbcodes")."\";");
    				}
    				if ($allowsmilies == 1) {
     					$result = $db->query("SELECT * FROM bgb".$n."_smilies");
     					$totalSmilies = $db->num_rows($result);

     					if ($smilie_view == -1 || $smilie_view >= $totalSmilies) $smilie_view = $totalSmilies;
     					else if ($smilie_view < $totalSmilies) eval("\$addentry_smilies_getmore = \"".$template->get("addentry_smilies_getmore")."\";");

     					$i=0;
     					while ($row = $db->fetch_array($result)) {
      						eval("\$smilieArray[\"".$i."\"] = \"".$template->get("addentry_smiliebit")."\";");
      						$i++;
     					}

     					$tableRows = ceil($smilie_view / $smilie_view_cols);
     					$countx = 0;
     					$smiliebits = "";
     					for ($i = 0; $i < $tableRows; $i++) {
      						$smiliebits .= "\t<tr bgcolor=\"{tablea}\" id=\"tablea\">\n";
      						for ($j = 0; $j < $smilie_view_cols; $j++) {
       							$smiliebits .= "\t<td align=\"center\">".$smilieArray[$countx]."&nbsp;</td>\n";
       							$countx++;
      						}
      						$smiliebits .= "\t</tr>\n";
     					}
     					eval("\$addentry_smilies = \"".$template->get("addentry_smilies")."\";");
    				}
    				eval("\$codes = \"".$template->get("addentry_codes")."\";");
   			}
  		}
 	}

 	eval("\$postbit .= \"".$template->get("view_postbit".$suffix)."\";");
}

$header 	= "";
$footer 	= "";
$pagelink 	= "";
$priorpage 	= "";
$nextpage 	= "";

if ($pages > 1) {
 	if ($page > 1) {
  		$prior = $page-1;
  		eval("\$priorpage = \"".$template->get("view_priorpage")."\";");
 	}

 	$pagelink = makepagelink("view.php", $page, $pages);

 	if ($page < $pages) {
  		$next = $page + 1;
  		eval("\$nextpage = \"".$template->get("view_nextpage")."\";");
 	}
}



eval("\$template->output(\"".$template->get("view")."\",2);");
?>